unit hiRARProgressBar; { ProgressBar  WinRar'a ver 3.00 }

interface

uses Windows,Messages,Kol,Share,Debug,Win;

type
  THIRARProgressBar = class(THIWin)
  private
    FPosition1,FPosition2,FPercent1,FPercent2: integer;
    FDouble: boolean;
    FMin,FMax: integer;
    FGradient: boolean;
    FLightColor1,FDarkColor,FLightColor2,FFrameColor1,FFrameColor2,
    FFillColor1,FFillColor2,FBackFrameColor1,FBackFrameColor2,
    FBackFillColor,FShadowColor: TColor;

    TopX,TopY,SizeX,SizeY: integer;

    procedure SetPos1(Val: integer);
    procedure SetPos2(Val: integer);
    procedure SetMin(Val: integer);
    procedure SetMax(Val: integer);
    procedure Paint;
    procedure _OnClick( Sender: PObj );

  public

    _event_OnClick: THI_Event;
    procedure Init; override;

    procedure _work_doPosition1(var _Data:TData; Index:word);
    procedure _work_doPosition2(var _Data:TData; Index:word);
    procedure _work_doMax(var _Data:TData; Index:word);
    procedure _work_doMin(var _Data:TData; Index:word);
    procedure _work_doDouble(var _Data:TData; Index:word);
    procedure _work_doGradient(var _Data:TData; Index:word);
    procedure _var_Position1(var _Data:TData; Index:word);
    procedure _var_Position2(var _Data:TData; Index:word);
    procedure _var_Percent1(var _Data:TData; Index:word);
    procedure _var_Percent2(var _Data:TData; Index:word);

    property _prop_Double: boolean     write FDouble;
    property _prop_Gradient: boolean   write FGradient;
    property _prop_Max: integer        write FMax;
    property _prop_Min: integer        write FMin;
  end;

implementation

//-----------------------       ----------------------

type

  AGRBQuad = array [0..0] of RGBQuad;
  PAGRBQuad = ^AGRBQuad;

  PPoints = ^TPoints;
  TPoints = array[0..0] of TPoint;

  PColor = ^TColor;

function GetLightColor(Color: TColor; Light: Byte) : TColor;
var   fFrom: TRGB;
begin
  PColor(@fFrom)^:= Color2RGB(Color);
  Result := RGB(
    (FFrom.R*100 + (255 - FFrom.R) * Light) div 100,
    (FFrom.G*100 + (255 - FFrom.G) * Light) div 100,
    (FFrom.B*100 + (255 - FFrom.B) * Light) div 100
  );
end;

function GetShadeColor(Color: TColor; Shade: Byte) : TColor;
var   fFrom: TRGB;
begin
  PColor(@fFrom)^:= Color2RGB(Color);
  Result := RGB(
    Max(0, FFrom.R - Shade),
    Max(0, FFrom.G - Shade),
    Max(0, FFrom.B - Shade)
  );
end;

//******************************  **************************************
  
type
  COLOR16 = $0000..$FF00;
  TTriVertex = packed record
    x, y: DWORD;
    Red, Green, Blue, Alpha: COLOR16;
  end;
function GradientFill(DC: HDC; Vertex: Pointer; NumVertex: Cardinal;
                      Mesh: Pointer; NumMesh, Mode: DWORD): BOOL; stdcall;
                      external 'msimg32.dll' name 'GradientFill';

procedure _Gradient(Sender: PBitmap; DC:HDC; cbRect:TRect; Gradient:boolean; DepthGradient:integer;
                    StartColor,EndColor,ColorFrame:TColor; Frame,Horizontal,InversGrad:boolean);
var   hdcMem:HDC;
      hdcBmp:HBITMAP;
      hWidth,hHeight:integer;
      vert: array[0..1] of TTriVertex;
      gRect: TGradientRect;
begin
   with Sender{$ifndef F_P}^{$endif} do begin
      hWidth:= cbRect.Right - cbRect.Left;
      hHeight:= cbRect.Bottom - cbRect.Top;
      hdcMem:= CreateCompatibleDC(0);
      hdcBmp:= CreateCompatibleBitmap(DC,hWidth,hHeight);
      SelectObject(hdcMem, hdcBmp);

      StartColor := Color2RGB(StartColor);
      EndColor := Color2RGB(EndColor); 

      if Gradient then
         StartColor:= GetLightColor(StartColor, max(0,min(100,DepthGradient)))
      else
         EndColor := StartColor; 
       
      //  
      if Frame then begin
         vert[0].x      := 1;
         vert[0].y      := 1;
         vert[1].x      := hWidth-1;
         vert[1].y      := hHeight-1;
         Canvas.Brush.Color:= Color2RGB(ColorFrame);
         FillRect(hdcMem,MakeRect(0,0,hWidth,hHeight),Canvas.Brush.Handle);
      end else begin
         vert[0].x      := 0;
         vert[0].y      := 0;
         vert[1].x      := hWidth;
         vert[1].y      := hHeight;
      end;
      vert[0].Alpha  := $ff00; // ???
      vert[1].Alpha  := vert[0].Alpha;  

      if not InversGrad then begin
         vert[0].Red    := GetRValue(StartColor) shl 8; //   
         vert[0].Green  := GetGValue(StartColor) shl 8; //   1 ,
         vert[0].Blue   := GetBValue(StartColor) shl 8; //   2 .
         vert[1].Red    := GetRValue(EndColor) shl 8;
         vert[1].Green  := GetGValue(EndColor) shl 8;
         vert[1].Blue   := GetBValue(EndColor) shl 8;
      end else begin
         vert[1].Red    := GetRValue(StartColor) shl 8; //   
         vert[1].Green  := GetGValue(StartColor) shl 8; //   1 ,
         vert[1].Blue   := GetBValue(StartColor) shl 8; //   2 .
         vert[0].Red    := GetRValue(EndColor) shl 8;
         vert[0].Green  := GetGValue(EndColor) shl 8;
         vert[0].Blue   := GetBValue(EndColor) shl 8;
      end;

      gRect.UpperLeft  := 0; //   
      gRect.LowerRight := 1; //   .

      //     
      if Horizontal then
         GradientFill(hdcMem, @vert, 2, @gRect, 1, GRADIENT_FILL_RECT_H)
      else
         GradientFill(hdcMem, @vert, 2, @gRect, 1, GRADIENT_FILL_RECT_V);
      BitBlt(DC, cbRect.Left, cbRect.Top, hWidth, hHeight, hdcMem, 0, 0, SRCCOPY);
      DeleteDC(hdcMem);
      DeleteObject(hdcBmp);
   end;
end;

//******************************************************************************

function WndProcRARProgressBar( Sender: PControl; var Msg: TMsg; var Rslt: Integer ): Boolean;
var   P: TPaintStruct;
      fControl: ThiRARProgressBar; 
begin
  Result:=False;
  fControl := ThiRARProgressBar(Sender.Tag); 
  if (msg.message = WM_PAINT) or (msg.message = WM_SIZE) then begin
     BeginPaint(Sender.Handle,P);
        fControl.Paint;
     EndPaint(Sender.handle,P);
     Result:=True;
     Rslt := 0;
  end;
end;

function Bounds(ALeft,ATop,AWidth,AHeight: integer): TRect;
begin
   with Result do begin
      Left := ALeft;
      Top := ATop;
      Right := ALeft + AWidth;
      Bottom := ATop + AHeight;
   end;
end;

procedure THIRARProgressBar.SetMin;
begin
  if Val > FMax then Val := FMax;
  FMin := Val;
end;

procedure THIRARProgressBar.SetMax;
begin
  if Val < FMin then Val := FMin;
  FMax := Val;
end;

procedure THIRARProgressBar.SetPos1;
begin
  if FDouble then if Val < FPosition2 then Val := FPosition2;
  if Val > FMax then Val := FMax
  else if Val < FMin then Val := FMin;
  FPosition1 := Val;
end;

procedure THIRARProgressBar.SetPos2;
begin
  if FDouble then if Val > FPosition1 then Val := FPosition1;
  if Val < FMin then Val := FMin; 
  FPosition2 := Val;
end;

procedure THIRARProgressBar.Paint;
var   R: real;
      Prog: integer;
      B: PBitmap;
begin
   with Control{$ifndef F_P}^{$endif} do begin
      B:=NewDIBBitmap(Width,Height,pf32bit);
   TRY
      TopX:=2;
      TopY:=2;
      SizeX:= Width-TopX-2;
      SizeY:= Height-TopY-4;
      if (SizeX=0) or (SizeY=0) or (FMax-FMin=0) then Exit;

///////////////////////////////////////////////////////////////////////////////
//               
///////////////////////////////////////////////////////////////////////////////

      with B.Canvas{$ifndef F_P}^{$endif} do begin
         Brush.BrushStyle:=bsSolid;
         Brush.Color := Color;
         FillRect(Bounds(0,0,B.Width,B.Height));
         Brush.Color := FShadowColor;
         FillRect(Bounds(TopX+1,TopY+2,SizeX,SizeY));
         _Gradient(B,Handle,Bounds(TopX,TopY,SizeX,SizeY),FGradient,0,
                   FBackFillColor, GetShadeColor(FBackFillColor,50),FBackFrameColor1,true,false,false);

///////////////////////////////////////////////////////////////////////////////
//                
///////////////////////////////////////////////////////////////////////////////

         R:=(FPosition1-FMin)/((FMax-FMin)/SizeX);
         Prog:=Round(R);
         FPercent1:=Byte(Round(R/(SizeX/100)));
         if Prog <> 0 then begin
            Brush.Color:=FLightColor1;
            FillRect(Bounds(TopX,TopY,TopX+Prog-2,TopY+SizeY-2));
            if Prog > 1 then
               _Gradient(B,Handle,Bounds(TopX+1,TopY+1,TopX+Prog-3,TopY+SizeY-3),FGradient,0,
                         FFillColor1, GetShadeColor(FFillColor1,70),FFrameColor1,true,false,false);
            if Prog < SizeX-1 then
               _Gradient(B,Handle,Bounds(TopX+Prog+1,TopY,SizeX-Prog-1,SizeY),FGradient,0,
                         FBackFillColor, GetShadeColor(FBackFillColor,50),FBackFrameColor1,true,false,false);
         end;

///////////////////////////////////////////////////////////////////////////////
//                
///////////////////////////////////////////////////////////////////////////////

         if FDouble then begin
            R:=(FPosition2-FMin)/((FMax-FMin)/SizeX);
            Prog:=Round(R);
            FPercent2:=Byte(Round(R/(SizeX/100)));
            if Prog<>0 then begin
               Brush.Color:=FLightColor2;
               FillRect(Bounds(TopX,TopY,TopX+Prog-2,TopY+SizeY-2));
               if Prog > 1 then
                  _Gradient(B,Handle,Bounds(TopX+1,TopY+1,TopX+Prog-3,TopY+SizeY-3),FGradient,0,
                            FFillColor2, GetShadeColor(FFillColor2,70),FFrameColor2,true,false,false); 
            end;
         end;
      end;
      B.Draw( Canvas.Handle, 0, 0 );
   FINALLY
      B.free;
   END;
   end;
end;

procedure  THIRARProgressBar.Init;
begin
   Control := NewPaintbox(FParent);
   Control.Tag := longint(Self);

   FPosition1 := FMin;
   FPosition2 := FMax;   
   FLightColor1:= clWhite;
   FDarkColor:= $606060;
   FLightColor2:= $C0FFFF;
   FFrameColor1:= $EEE8E8;
   FFrameColor2:= $B4D4E4;
   FFillColor1:= $DCD6D6;
   FFillColor2:= $A0C0D0;
   FBackFrameColor1:= $9494B4;
   FBackFrameColor2:= $80809E;
   FBackFillColor:= $6E6E94;
   FShadowColor:= $464040;

   Control.Attachproc(WndProcRARProgressBar);
   Control.OnClick := _OnClick;
inherited;
end;

procedure THIRARProgressBar._OnClick;
begin
   _hi_OnEvent(_event_OnClick);
end;

procedure THIRARProgressBar._work_doDouble;begin FDouble := ReadBool(_Data);Paint;end;
procedure THIRARProgressBar._work_doGradient;begin FGradient := ReadBool(_Data);Paint;end;
procedure THIRARProgressBar._work_doPosition1;begin SetPos1(ToInteger(_Data));Paint;end;
procedure THIRARProgressBar._work_doPosition2;begin SetPos2(ToInteger(_Data));Paint;end;
procedure THIRARProgressBar._work_doMax;begin SetMax(ToInteger(_Data));Paint;end;
procedure THIRARProgressBar._work_doMin;begin SetMin(ToInteger(_Data));Paint;end;
procedure THIRARProgressBar._var_Position1;begin dtInteger(_Data,FPosition1);end;
procedure THIRARProgressBar._var_Position2;begin dtInteger(_Data,FPosition2);end;
procedure THIRARProgressBar._var_Percent1;begin dtInteger(_Data, FPercent1);end;
procedure THIRARProgressBar._var_Percent2;begin dtInteger(_Data,FPercent2);end;

end.